# ------------------
# Sugar
# QQ: 932180146
# ------------------

module RBC
  module Extensions
    module SectionPlaneTools

      # check lib.
      #
      # @param [String] ext_name
      #
      # @return [Boolean]
      #
      # @since 6.3.0
      def self.check_lib?(ext_name, mv, rv, fv)
        return false if defined?(RBC::LIB_UPDATE_) && RBC::LIB_UPDATE_
        return false if Sketchup.version.to_i < 15
        unless defined?(RBC::RBC_EXTENSION)
          # require RBC library.
          begin
            require 'RBC_Library_load.rb'
          rescue LoadError => e
            p e
          end
        end
        if defined?(RBC::RBC_VERSION_) && RBC::RBC_VERSION_[0] == mv
          if RBC::RBC_VERSION_[1] >= rv
             if RBC::RBC_VERSION_[2] >= fv
               update = false
             else
               update = true
             end
           else
             update = true
           end

        else
          update = true
        end
        # check version.
        if update
          msg = "#{ext_name}: RBC Library(#{mv}.#{rv}.#{fv}) must be installed!(必须安装使用#{mv}.#{rv}.#{fv}版本以上的RBC Library!)"
          Sketchup.status_text = msg
          if Sketchup.version.to_i >= 17
            UI::Notification.new(Sketchup.extensions.first, msg).show
          else
            UI.messagebox(msg)
          end
          RBC.const_set(:LIB_UPDATE_ ,true)
          false
        end
        !update
      end

      #
      NAME = 'RBC_SectionPlaneTools'.freeze
      VERSION = '7.6.1'.freeze
      DIR_NAME = (NAME + '_v' + VERSION).freeze
      EXTENSION_DIR = File.join(__dir__, DIR_NAME).freeze

      #
      if self.check_lib?(DIR_NAME, 7, 6, 0)
        LH = RBC::LanguageHandler.new(File.join(EXTENSION_DIR, 'Resources'))
        LH.name= LH[NAME]
        EXTENSION = SketchupExtension.new(NAME, File.join(EXTENSION_DIR, 'core'))
        EXTENSION.description = LH[NAME]
        EXTENSION.copyright = "Copyright (c) #{Time.new.year} Sugar All rights reserved."
        EXTENSION.version = VERSION
        EXTENSION.creator = 'Sugar'
        Sketchup.register_extension(EXTENSION, true)
      end

    end # module SectionPlaneTools
  end # module Extensions
end # module RBC


